<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/textwrap-0.15.0/src/core.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>core.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../textwrap/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../textwrap/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
</pre><pre class="rust"><code><span class="doccomment">//! Building blocks for advanced wrapping functionality.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The functions and structs in this module can be used to implement</span>
<span class="doccomment">//! advanced wrapping functionality when the [`wrap`](super::wrap) and</span>
<span class="doccomment">//! [`fill`](super::fill) function don&#39;t do what you want.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In general, you want to follow these steps when wrapping</span>
<span class="doccomment">//! something:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! 1. Split your input into [`Fragment`]s. These are abstract blocks</span>
<span class="doccomment">//!    of text or content which can be wrapped into lines. See</span>
<span class="doccomment">//!    [`WordSeparator`](crate::word_separators::WordSeparator) for</span>
<span class="doccomment">//!    how to do this for text.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! 2. Potentially split your fragments into smaller pieces. This</span>
<span class="doccomment">//!    allows you to implement things like hyphenation. If you use the</span>
<span class="doccomment">//!    `Word` type, you can use [`WordSplitter`](crate::WordSplitter)</span>
<span class="doccomment">//!    enum for this.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! 3. Potentially break apart fragments that are still too large to</span>
<span class="doccomment">//!    fit on a single line. This is implemented in [`break_words`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! 4. Finally take your fragments and put them into lines. There are</span>
<span class="doccomment">//!    two algorithms for this in the</span>
<span class="doccomment">//!    [`wrap_algorithms`](crate::wrap_algorithms) module:</span>
<span class="doccomment">//!    [`wrap_optimal_fit`](crate::wrap_algorithms::wrap_optimal_fit)</span>
<span class="doccomment">//!    and [`wrap_first_fit`](crate::wrap_algorithms::wrap_first_fit).</span>
<span class="doccomment">//!    The former produces better line breaks, the latter is faster.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! 5. Iterate through the slices returned by the wrapping functions</span>
<span class="doccomment">//!    and construct your lines of output.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Please [open an issue](https://github.com/mgeisler/textwrap/) if</span>
<span class="doccomment">//! the functionality here is not sufficient or if you have ideas for</span>
<span class="doccomment">//! improving it. We would love to hear from you!</span>

<span class="doccomment">/// The CSI or “Control Sequence Introducer” introduces an ANSI escape</span>
<span class="doccomment">/// sequence. This is typically used for colored text and will be</span>
<span class="doccomment">/// ignored when computing the text width.</span>
<span class="kw">const</span> <span class="ident">CSI</span>: (<span class="ident">char</span>, <span class="ident">char</span>) <span class="op">=</span> (<span class="string">&#39;\x1b&#39;</span>, <span class="string">&#39;[&#39;</span>);
<span class="doccomment">/// The final bytes of an ANSI escape sequence must be in this range.</span>
<span class="kw">const</span> <span class="ident">ANSI_FINAL_BYTE</span>: <span class="ident">std::ops::RangeInclusive</span><span class="op">&lt;</span><span class="ident">char</span><span class="op">&gt;</span> <span class="op">=</span> <span class="string">&#39;\x40&#39;</span>..<span class="op">=</span><span class="string">&#39;\x7e&#39;</span>;

<span class="doccomment">/// Skip ANSI escape sequences. The `ch` is the current `char`, the</span>
<span class="doccomment">/// `chars` provide the following characters. The `chars` will be</span>
<span class="doccomment">/// modified if `ch` is the start of an ANSI escape sequence.</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">skip_ansi_escape_sequence</span><span class="op">&lt;</span><span class="ident">I</span>: <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">char</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">ch</span>: <span class="ident">char</span>, <span class="ident">chars</span>: <span class="kw-2">&amp;mut</span> <span class="ident">I</span>) -&gt; <span class="ident">bool</span> {
    <span class="kw">if</span> <span class="ident">ch</span> <span class="op">==</span> <span class="ident">CSI</span>.<span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="ident">chars</span>.<span class="ident">next</span>() <span class="op">==</span> <span class="prelude-val">Some</span>(<span class="ident">CSI</span>.<span class="number">1</span>) {
        <span class="comment">// We have found the start of an ANSI escape code, typically</span>
        <span class="comment">// used for colored terminal text. We skip until we find a</span>
        <span class="comment">// &quot;final byte&quot; in the range 0x40–0x7E.</span>
        <span class="kw">for</span> <span class="ident">ch</span> <span class="kw">in</span> <span class="ident">chars</span> {
            <span class="kw">if</span> <span class="ident">ANSI_FINAL_BYTE</span>.<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="ident">ch</span>) {
                <span class="kw">return</span> <span class="bool-val">true</span>;
            }
        }
    }
    <span class="bool-val">false</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">fn</span> <span class="ident">ch_width</span>(<span class="ident">ch</span>: <span class="ident">char</span>) -&gt; <span class="ident">usize</span> {
    <span class="ident">unicode_width::UnicodeWidthChar::width</span>(<span class="ident">ch</span>).<span class="ident">unwrap_or</span>(<span class="number">0</span>)
}

<span class="doccomment">/// First character which [`ch_width`] will classify as double-width.</span>
<span class="doccomment">/// Please see [`display_width`].</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>))]</span>
<span class="kw">const</span> <span class="ident">DOUBLE_WIDTH_CUTOFF</span>: <span class="ident">char</span> <span class="op">=</span> <span class="string">&#39;\u{1100}&#39;</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>))]</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">fn</span> <span class="ident">ch_width</span>(<span class="ident">ch</span>: <span class="ident">char</span>) -&gt; <span class="ident">usize</span> {
    <span class="kw">if</span> <span class="ident">ch</span> <span class="op">&lt;</span> <span class="ident">DOUBLE_WIDTH_CUTOFF</span> {
        <span class="number">1</span>
    } <span class="kw">else</span> {
        <span class="number">2</span>
    }
}

<span class="doccomment">/// Compute the display width of `text` while skipping over ANSI</span>
<span class="doccomment">/// escape sequences.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::display_width;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;Café Plain&quot;), 10);</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;\u{1b}[31mCafé Rouge\u{1b}[0m&quot;), 10);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// **Note:** When the `unicode-width` Cargo feature is disabled, the</span>
<span class="doccomment">/// width of a `char` is determined by a crude approximation which</span>
<span class="doccomment">/// simply counts chars below U+1100 as 1 column wide, and all other</span>
<span class="doccomment">/// characters as 2 columns wide. With the feature enabled, function</span>
<span class="doccomment">/// will correctly deal with [combining characters] in their</span>
<span class="doccomment">/// decomposed form (see [Unicode equivalence]).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// An example of a decomposed character is “é”, which can be</span>
<span class="doccomment">/// decomposed into: “e” followed by a combining acute accent: “◌́”.</span>
<span class="doccomment">/// Without the `unicode-width` Cargo feature, every `char` below</span>
<span class="doccomment">/// U+1100 has a width of 1. This includes the combining accent:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::display_width;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;Cafe Plain&quot;), 10);</span>
<span class="doccomment">/// #[cfg(feature = &quot;unicode-width&quot;)]</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;Cafe\u{301} Plain&quot;), 10);</span>
<span class="doccomment">/// #[cfg(not(feature = &quot;unicode-width&quot;))]</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;Cafe\u{301} Plain&quot;), 11);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ## Emojis and CJK Characters</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Characters such as emojis and [CJK characters] used in the</span>
<span class="doccomment">/// Chinese, Japanese, and Korean langauges are seen as double-width,</span>
<span class="doccomment">/// even if the `unicode-width` feature is disabled:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::display_width;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;😂😭🥺🤣✨😍🙏🥰😊🔥&quot;), 20);</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;你好&quot;), 4);  // “Nǐ hǎo” or “Hello” in Chinese</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Limitations</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The displayed width of a string cannot always be computed from the</span>
<span class="doccomment">/// string alone. This is because the width depends on the rendering</span>
<span class="doccomment">/// engine used. This is particularly visible with [emoji modifier</span>
<span class="doccomment">/// sequences] where a base emoji is modified with, e.g., skin tone or</span>
<span class="doccomment">/// hair color modifiers. It is up to the rendering engine to detect</span>
<span class="doccomment">/// this and to produce a suitable emoji.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A simple example is “❤️”, which consists of “❤” (U+2764: Black</span>
<span class="doccomment">/// Heart Symbol) followed by U+FE0F (Variation Selector-16). By</span>
<span class="doccomment">/// itself, “❤” is a black heart, but if you follow it with the</span>
<span class="doccomment">/// variant selector, you may get a wider red heart.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A more complex example would be “👨‍🦰” which should depict a man</span>
<span class="doccomment">/// with red hair. Here the computed width is too large — and the</span>
<span class="doccomment">/// width differs depending on the use of the `unicode-width` feature:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use textwrap::core::display_width;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// assert_eq!(&quot;👨‍🦰&quot;.chars().collect::&lt;Vec&lt;char&gt;&gt;(), [&#39;\u{1f468}&#39;, &#39;\u{200d}&#39;, &#39;\u{1f9b0}&#39;]);</span>
<span class="doccomment">/// #[cfg(feature = &quot;unicode-width&quot;)]</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;👨‍🦰&quot;), 4);</span>
<span class="doccomment">/// #[cfg(not(feature = &quot;unicode-width&quot;))]</span>
<span class="doccomment">/// assert_eq!(display_width(&quot;👨‍🦰&quot;), 6);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This happens because the grapheme consists of three code points:</span>
<span class="doccomment">/// “👨” (U+1F468: Man), Zero Width Joiner (U+200D), and “🦰”</span>
<span class="doccomment">/// (U+1F9B0: Red Hair). You can see them above in the test. With</span>
<span class="doccomment">/// `unicode-width` enabled, the ZWJ is correctly seen as having zero</span>
<span class="doccomment">/// width, without it is counted as a double-width character.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ## Terminal Support</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Modern browsers typically do a great job at combining characters</span>
<span class="doccomment">/// as shown above, but terminals often struggle more. As an example,</span>
<span class="doccomment">/// Gnome Terminal version 3.38.1, shows “❤️” as a big red heart, but</span>
<span class="doccomment">/// shows &quot;👨‍🦰&quot; as “👨🦰”.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [combining characters]: https://en.wikipedia.org/wiki/Combining_character</span>
<span class="doccomment">/// [Unicode equivalence]: https://en.wikipedia.org/wiki/Unicode_equivalence</span>
<span class="doccomment">/// [CJK characters]: https://en.wikipedia.org/wiki/CJK_characters</span>
<span class="doccomment">/// [emoji modifier sequences]: https://unicode.org/emoji/charts/full-emoji-modifiers.html</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">display_width</span>(<span class="ident">text</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">usize</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">chars</span> <span class="op">=</span> <span class="ident">text</span>.<span class="ident">chars</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">width</span> <span class="op">=</span> <span class="number">0</span>;
    <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">ch</span>) <span class="op">=</span> <span class="ident">chars</span>.<span class="ident">next</span>() {
        <span class="kw">if</span> <span class="ident">skip_ansi_escape_sequence</span>(<span class="ident">ch</span>, <span class="kw-2">&amp;mut</span> <span class="ident">chars</span>) {
            <span class="kw">continue</span>;
        }
        <span class="ident">width</span> <span class="op">+</span><span class="op">=</span> <span class="ident">ch_width</span>(<span class="ident">ch</span>);
    }
    <span class="ident">width</span>
}

<span class="doccomment">/// A (text) fragment denotes the unit which we wrap into lines.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Fragments represent an abstract _word_ plus the _whitespace_</span>
<span class="doccomment">/// following the word. In case the word falls at the end of the line,</span>
<span class="doccomment">/// the whitespace is dropped and a so-called _penalty_ is inserted</span>
<span class="doccomment">/// instead (typically `&quot;-&quot;` if the word was hyphenated).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For wrapping purposes, the precise content of the word, the</span>
<span class="doccomment">/// whitespace, and the penalty is irrelevant. All we need to know is</span>
<span class="doccomment">/// the displayed width of each part, which this trait provides.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Fragment</span>: <span class="ident">std::fmt::Debug</span> {
    <span class="doccomment">/// Displayed width of word represented by this fragment.</span>
    <span class="kw">fn</span> <span class="ident">width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span>;

    <span class="doccomment">/// Displayed width of the whitespace that must follow the word</span>
    <span class="doccomment">/// when the word is not at the end of a line.</span>
    <span class="kw">fn</span> <span class="ident">whitespace_width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span>;

    <span class="doccomment">/// Displayed width of the penalty that must be inserted if the</span>
    <span class="doccomment">/// word falls at the end of a line.</span>
    <span class="kw">fn</span> <span class="ident">penalty_width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span>;
}

<span class="doccomment">/// A piece of wrappable text, including any trailing whitespace.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A `Word` is an example of a [`Fragment`], so it has a width,</span>
<span class="doccomment">/// trailing whitespace, and potentially a penalty item.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Word content.</span>
    <span class="kw">pub</span> <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
    <span class="doccomment">/// Whitespace to insert if the word does not fall at the end of a line.</span>
    <span class="kw">pub</span> <span class="ident">whitespace</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
    <span class="doccomment">/// Penalty string to insert if the word falls at the end of a line.</span>
    <span class="kw">pub</span> <span class="ident">penalty</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>,
    <span class="comment">// Cached width in columns.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">width</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span> <span class="ident">std::ops::Deref</span> <span class="kw">for</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Target</span> <span class="op">=</span> <span class="ident">str</span>;

    <span class="kw">fn</span> <span class="ident">deref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Target</span> {
        <span class="self">self</span>.<span class="ident">word</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Construct a `Word` from a string.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// A trailing stretch of `&#39; &#39;` is automatically taken to be the</span>
    <span class="doccomment">/// whitespace part of the word.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">trimmed</span> <span class="op">=</span> <span class="ident">word</span>.<span class="ident">trim_end_matches</span>(<span class="string">&#39; &#39;</span>);
        <span class="ident">Word</span> {
            <span class="ident">word</span>: <span class="ident">trimmed</span>,
            <span class="ident">width</span>: <span class="ident">display_width</span>(<span class="ident">trimmed</span>),
            <span class="ident">whitespace</span>: <span class="kw-2">&amp;</span><span class="ident">word</span>[<span class="ident">trimmed</span>.<span class="ident">len</span>()..],
            <span class="ident">penalty</span>: <span class="string">&quot;&quot;</span>,
        }
    }

    <span class="doccomment">/// Break this word into smaller words with a width of at most</span>
    <span class="doccomment">/// `line_width`. The whitespace and penalty from this `Word` is</span>
    <span class="doccomment">/// added to the last piece.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use textwrap::core::Word;</span>
    <span class="doccomment">/// assert_eq!(</span>
    <span class="doccomment">///     Word::from(&quot;Hello!  &quot;).break_apart(3).collect::&lt;Vec&lt;_&gt;&gt;(),</span>
    <span class="doccomment">///     vec![Word::from(&quot;Hel&quot;), Word::from(&quot;lo!  &quot;)]</span>
    <span class="doccomment">/// );</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">break_apart</span><span class="op">&lt;</span><span class="lifetime">&#39;b</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;b</span> <span class="self">self</span>, <span class="ident">line_width</span>: <span class="ident">usize</span>) -&gt; <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;b</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">char_indices</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">word</span>.<span class="ident">char_indices</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">offset</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">width</span> <span class="op">=</span> <span class="number">0</span>;

        <span class="ident">std::iter::from_fn</span>(<span class="kw">move</span> <span class="op">|</span><span class="op">|</span> {
            <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">idx</span>, <span class="ident">ch</span>)) <span class="op">=</span> <span class="ident">char_indices</span>.<span class="ident">next</span>() {
                <span class="kw">if</span> <span class="ident">skip_ansi_escape_sequence</span>(<span class="ident">ch</span>, <span class="kw-2">&amp;mut</span> <span class="ident">char_indices</span>.<span class="ident">by_ref</span>().<span class="ident">map</span>(<span class="op">|</span>(<span class="kw">_</span>, <span class="ident">ch</span>)<span class="op">|</span> <span class="ident">ch</span>)) {
                    <span class="kw">continue</span>;
                }

                <span class="kw">if</span> <span class="ident">width</span> <span class="op">&gt;</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="ident">width</span> <span class="op">+</span> <span class="ident">ch_width</span>(<span class="ident">ch</span>) <span class="op">&gt;</span> <span class="ident">line_width</span> {
                    <span class="kw">let</span> <span class="ident">word</span> <span class="op">=</span> <span class="ident">Word</span> {
                        <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">word</span>[<span class="ident">offset</span>..<span class="ident">idx</span>],
                        <span class="ident">width</span>: <span class="ident">width</span>,
                        <span class="ident">whitespace</span>: <span class="string">&quot;&quot;</span>,
                        <span class="ident">penalty</span>: <span class="string">&quot;&quot;</span>,
                    };
                    <span class="ident">offset</span> <span class="op">=</span> <span class="ident">idx</span>;
                    <span class="ident">width</span> <span class="op">=</span> <span class="ident">ch_width</span>(<span class="ident">ch</span>);
                    <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">word</span>);
                }

                <span class="ident">width</span> <span class="op">+</span><span class="op">=</span> <span class="ident">ch_width</span>(<span class="ident">ch</span>);
            }

            <span class="kw">if</span> <span class="ident">offset</span> <span class="op">&lt;</span> <span class="self">self</span>.<span class="ident">word</span>.<span class="ident">len</span>() {
                <span class="kw">let</span> <span class="ident">word</span> <span class="op">=</span> <span class="ident">Word</span> {
                    <span class="ident">word</span>: <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">word</span>[<span class="ident">offset</span>..],
                    <span class="ident">width</span>: <span class="ident">width</span>,
                    <span class="ident">whitespace</span>: <span class="self">self</span>.<span class="ident">whitespace</span>,
                    <span class="ident">penalty</span>: <span class="self">self</span>.<span class="ident">penalty</span>,
                };
                <span class="ident">offset</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">word</span>.<span class="ident">len</span>();
                <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">word</span>);
            }

            <span class="prelude-val">None</span>
        })
    }
}

<span class="kw">impl</span> <span class="ident">Fragment</span> <span class="kw">for</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span> {
        <span class="self">self</span>.<span class="ident">width</span> <span class="kw">as</span> <span class="ident">f64</span>
    }

    <span class="comment">// We assume the whitespace consist of &#39; &#39; only. This allows us to</span>
    <span class="comment">// compute the display width in constant time.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">whitespace_width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span> {
        <span class="self">self</span>.<span class="ident">whitespace</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">f64</span>
    }

    <span class="comment">// We assume the penalty is `&quot;&quot;` or `&quot;-&quot;`. This allows us to</span>
    <span class="comment">// compute the display width in constant time.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">penalty_width</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">f64</span> {
        <span class="self">self</span>.<span class="ident">penalty</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">f64</span>
    }
}

<span class="doccomment">/// Forcibly break words wider than `line_width` into smaller words.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This simply calls [`Word::break_apart`] on words that are too</span>
<span class="doccomment">/// wide. This means that no extra `&#39;-&#39;` is inserted, the word is</span>
<span class="doccomment">/// simply broken into smaller pieces.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">break_words</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">I</span><span class="op">&gt;</span>(<span class="ident">words</span>: <span class="ident">I</span>, <span class="ident">line_width</span>: <span class="ident">usize</span>) -&gt; <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">I</span>: <span class="ident">IntoIterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">Word</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span>,
{
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">shortened_words</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
    <span class="kw">for</span> <span class="ident">word</span> <span class="kw">in</span> <span class="ident">words</span> {
        <span class="kw">if</span> <span class="ident">word</span>.<span class="ident">width</span>() <span class="op">&gt;</span> <span class="ident">line_width</span> <span class="kw">as</span> <span class="ident">f64</span> {
            <span class="ident">shortened_words</span>.<span class="ident">extend</span>(<span class="ident">word</span>.<span class="ident">break_apart</span>(<span class="ident">line_width</span>));
        } <span class="kw">else</span> {
            <span class="ident">shortened_words</span>.<span class="ident">push</span>(<span class="ident">word</span>);
        }
    }
    <span class="ident">shortened_words</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>)]</span>
    <span class="kw">use</span> <span class="ident">unicode_width::UnicodeWidthChar</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">skip_ansi_escape_sequence_works</span>() {
        <span class="kw">let</span> <span class="ident">blue_text</span> <span class="op">=</span> <span class="string">&quot;\u{1b}[34mHello\u{1b}[0m&quot;</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">chars</span> <span class="op">=</span> <span class="ident">blue_text</span>.<span class="ident">chars</span>();
        <span class="kw">let</span> <span class="ident">ch</span> <span class="op">=</span> <span class="ident">chars</span>.<span class="ident">next</span>().<span class="ident">unwrap</span>();
        <span class="macro">assert!</span>(<span class="ident">skip_ansi_escape_sequence</span>(<span class="ident">ch</span>, <span class="kw-2">&amp;mut</span> <span class="ident">chars</span>));
        <span class="macro">assert_eq!</span>(<span class="ident">chars</span>.<span class="ident">next</span>(), <span class="prelude-val">Some</span>(<span class="string">&#39;H&#39;</span>));
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">emojis_have_correct_width</span>() {
        <span class="kw">use</span> <span class="ident">unic_emoji_char::is_emoji</span>;

        <span class="comment">// Emojis in the Basic Latin (ASCII) and Latin-1 Supplement</span>
        <span class="comment">// blocks all have a width of 1 column. This includes</span>
        <span class="comment">// characters such as &#39;#&#39; and &#39;©&#39;.</span>
        <span class="kw">for</span> <span class="ident">ch</span> <span class="kw">in</span> <span class="string">&#39;\u{1}&#39;</span>..<span class="string">&#39;\u{FF}&#39;</span> {
            <span class="kw">if</span> <span class="ident">is_emoji</span>(<span class="ident">ch</span>) {
                <span class="kw">let</span> <span class="ident">desc</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{:?} U+{:04X}&quot;</span>, <span class="ident">ch</span>, <span class="ident">ch</span> <span class="kw">as</span> <span class="ident">u32</span>);

                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>)]</span>
                <span class="macro">assert_eq!</span>(<span class="ident">ch</span>.<span class="ident">width</span>().<span class="ident">unwrap</span>(), <span class="number">1</span>, <span class="string">&quot;char: {}&quot;</span>, <span class="ident">desc</span>);

                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>))]</span>
                <span class="macro">assert_eq!</span>(<span class="ident">ch_width</span>(<span class="ident">ch</span>), <span class="number">1</span>, <span class="string">&quot;char: {}&quot;</span>, <span class="ident">desc</span>);
            }
        }

        <span class="comment">// Emojis in the remaining blocks of the Basic Multilingual</span>
        <span class="comment">// Plane (BMP), in the Supplementary Multilingual Plane (SMP),</span>
        <span class="comment">// and in the Supplementary Ideographic Plane (SIP), are all 1</span>
        <span class="comment">// or 2 columns wide when unicode-width is used, and always 2</span>
        <span class="comment">// columns wide otherwise. This includes all of our favorite</span>
        <span class="comment">// emojis such as 😊.</span>
        <span class="kw">for</span> <span class="ident">ch</span> <span class="kw">in</span> <span class="string">&#39;\u{FF}&#39;</span>..<span class="string">&#39;\u{2FFFF}&#39;</span> {
            <span class="kw">if</span> <span class="ident">is_emoji</span>(<span class="ident">ch</span>) {
                <span class="kw">let</span> <span class="ident">desc</span> <span class="op">=</span> <span class="macro">format!</span>(<span class="string">&quot;{:?} U+{:04X}&quot;</span>, <span class="ident">ch</span>, <span class="ident">ch</span> <span class="kw">as</span> <span class="ident">u32</span>);

                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>)]</span>
                <span class="macro">assert!</span>(<span class="ident">ch</span>.<span class="ident">width</span>().<span class="ident">unwrap</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="number">2</span>, <span class="string">&quot;char: {}&quot;</span>, <span class="ident">desc</span>);

                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>))]</span>
                <span class="macro">assert_eq!</span>(<span class="ident">ch_width</span>(<span class="ident">ch</span>), <span class="number">2</span>, <span class="string">&quot;char: {}&quot;</span>, <span class="ident">desc</span>);
            }
        }

        <span class="comment">// The remaining planes contain almost no assigned code points</span>
        <span class="comment">// and thus also no emojis.</span>
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">display_width_works</span>() {
        <span class="macro">assert_eq!</span>(<span class="string">&quot;Café Plain&quot;</span>.<span class="ident">len</span>(), <span class="number">11</span>); <span class="comment">// “é” is two bytes</span>
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;Café Plain&quot;</span>), <span class="number">10</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;\u{1b}[31mCafé Rouge\u{1b}[0m&quot;</span>), <span class="number">10</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">display_width_narrow_emojis</span>() {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>)]</span>
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;⁉&quot;</span>), <span class="number">1</span>);

        <span class="comment">// The ⁉ character is above DOUBLE_WIDTH_CUTOFF.</span>
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>))]</span>
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;⁉&quot;</span>), <span class="number">2</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">display_width_narrow_emojis_variant_selector</span>() {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>)]</span>
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;⁉\u{fe0f}&quot;</span>), <span class="number">1</span>);

        <span class="comment">// The variant selector-16 is also counted.</span>
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;unicode-width&quot;</span>))]</span>
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;⁉\u{fe0f}&quot;</span>), <span class="number">4</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">display_width_emojis</span>() {
        <span class="macro">assert_eq!</span>(<span class="ident">display_width</span>(<span class="string">&quot;😂😭🥺🤣✨😍🙏🥰😊🔥&quot;</span>), <span class="number">20</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="textwrap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>